#!/bin/bash
#rm -f ccnData.txt tcpData.txt
EXE=../build/myscripts/ccn-exp2/bin/dce-ccn-exp2
START=$1
STOP=$2
INC=$3
if [ $# -ge 4 ]
then
  SIZ=$4
else
  SIZ=200
fi
PSIZE=2048
function do_run 
{
   CCND=$1
   NN=$2
   SIZE=$3
   if [ $CCND -eq 0 ]
   then 
  	T=Tcp 
   else
    T=Ccn
   fi
   FILENAME=Exp2-$T-Node-Number-$NN-Size-Transfert-$SIZE-Kb
   rm -rf files-*
   /usr/bin/time -f '%e %M # Elapsed real time (in seconds) and Memory Max' $EXE --cv=5 --ccnd=$CCND --ct=udp --nb=$NN --total=$SIZE --size=$PSIZE --EnableMonitor=1 2>$FILENAME.simulation-time-and-memory
   cat $FILENAME*	   
}   
for ((n=$START;n<=$STOP;n+=$INC))
do
	do_run 0 $n $SIZ
	do_run 1 $n $SIZ
done
cat >Exp2-Ploter-$SIZ-Kb.txt <<EOF 
set xlabel "Number of Clients"
set ylabel "Total Download Time (ms)"
plot "Exp2-Ccn-$SIZ-Kb-Max-Time.txt"  using 1:2 title 'CCN-Max'   with linespoints , "Exp2-Tcp-$SIZ-Kb-Max-Time.txt" using 1:2 title 'TCP' with linespoints,"Exp2-Ccn-$SIZ-Kb-Average-Time.txt" using 1:2 title 'CCN-Average' with linespoints 
EOF
gnuplot Exp2-Ploter-$SIZ-Kb.txt -
